function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (global, factory) {
  (typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' ? module.exports = factory() : typeof define === 'function' && define.amd ? define(factory) : (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global['segi-tool-envpipe'] = factory());
})(this, function () {
  'use strict';
  /*
   * @Author: zuley
   * @Date: 2021-06-01 17:28:44
   * @LastEditors: zuley
   * @LastEditTime: 2021-06-09 13:43:02
   */

  var EnvPipe = /*#__PURE__*/function () {
    function EnvPipe() {
      _classCallCheck(this, EnvPipe);

      _defineProperty(this, "envList", {});

      _defineProperty(this, "actEnvName", 'default');
    }

    _createClass(EnvPipe, [{
      key: "defaultPipe",
      value: // 默认函数
      function defaultPipe() {
        console.log('没有设置默认管道方法');
        return null;
      } // 推入函数

    }, {
      key: "push",
      value: function push(env) {
        if (!this.envList[env.name]) {
          this.envList[env.name] = env;
        } else {
          console.log("环境重复，请检查 PUSH 的参数");
        }
      } // 启动函数

    }, {
      key: "start",
      value: function start(config) {
        var _this = this;

        return new Promise(function (resolve) {
          var _iterator = _createForOfIteratorHelper(config),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var envName = _step.value;
              var env = _this.envList[envName];

              if (env && env.in()) {
                _this.actEnvName = env.name;
                resolve(env.complete());
                break;
              }
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }

          if (_this.actEnvName === 'default') resolve(_this.defaultPipe());
        });
      }
    }]);

    return EnvPipe;
  }();

  return EnvPipe;
});
